(set-logic FP)

(define-sort FP () (_ FloatingPoint 3 5))

(define-const posMinSubnormal FP (fp #b0 #b000 #b0001))
(define-const negMinSubnormal FP (fp #b1 #b000 #b0001))
(define-const posMaxSubnormal FP (fp #b0 #b000 #b1111))
(define-const negMaxSubnormal FP (fp #b1 #b000 #b1111))
(define-const posMinNormal FP (fp #b0 #b001 #b0000))
(define-const negMinNormal FP (fp #b1 #b001 #b0000))
(define-const posMaxNormal FP (fp #b0 #b110 #b1111))
(define-const negMaxNormal FP (fp #b1 #b110 #b1111))
(define-const posConstTwo FP (fp #b0 #b100 #b0000))
(define-const R RoundingMode RNA)

(declare-const s FP)
(declare-const u FP)

(define-fun IC ((s FP) (t FP)) Bool (and (not (fp.isInfinite t)) (not (fp.isInfinite s)) (not (fp.isNaN t)) (not (fp.isNaN s)) (=> (and (fp.isNormal s) (fp.isNormal t)) (not (fp.isInfinite (fp.fma R s t (ite (= (fp.isPositive s) (fp.isPositive t)) negMaxNormal posMaxNormal)))))))

(assert
 (distinct
  (IC s u)
  (exists ((x FP)) (fp.isNormal (fp.fma RNA s u x)))
 )
)

(check-sat)
