(set-logic FP)

(define-sort FP () (_ FloatingPoint 8 24))

(define-const posMinSubnormal FP (fp #b0 #b00000000 #b00000000000000000000001))
(define-const negMinSubnormal FP (fp #b1 #b00000000 #b00000000000000000000001))
(define-const posMaxSubnormal FP (fp #b0 #b00000000 #b11111111111111111111111))
(define-const negMaxSubnormal FP (fp #b1 #b00000000 #b11111111111111111111111))
(define-const posMinNormal FP (fp #b0 #b00000001 #b00000000000000000000000))
(define-const negMinNormal FP (fp #b1 #b00000001 #b00000000000000000000000))
(define-const posMaxNormal FP (fp #b0 #b11111110 #b11111111111111111111111))
(define-const negMaxNormal FP (fp #b1 #b11111110 #b11111111111111111111111))
(define-const posConstTwo FP (fp #b0 #b10000000 #b00000000000000000000000))
(define-const R RoundingMode RNA)

(declare-const s FP)
(declare-const t FP)

(define-fun IC ((s FP) (t FP)) Bool (and (ite (and (not (fp.isZero s)) (not (fp.isNegative s)) (not (fp.isNormal s))) (and (fp.isSubnormal s) (or (not (fp.isNegative t)) (not (fp.isInfinite t)))) (or (not (fp.isNegative t)) (not (fp.isInfinite t)))) (not (fp.isNaN t))))

(assert
 (distinct
  (IC s t)
  (exists ((x FP)) (fp.lt (fp.sub RNA s x) t))
 )
)

(check-sat)
